; 00start.S
;  startup and setup I/O routine
; refer to http://yesavr.web.fc2.com/tiny2313/AVR_I2C_IO/AVR_I2C_IO.html
;
; Fuse configuration
; FX=11111111($ff)
; FH=11011011($db) BODat2.7 V
; FL=11100100($e4) 8MHzRCintOsc/1 (0.125us/cycle)
; LB=11111111($ff)

; PA2/RESET#2 	PU10k

; PA1/XTAL2 	-
; PA0/XTAL1 	-

; PD6/ICP   	LCD_E
; PD5/OC0B/T1	LCD_RS
; PD4/T0    	LCD_RW
; PD3/INT1  	/INT
; PD2/INT0  	BTNLED
; PD1/TXD   	TxD
; PD0/RXD   	RxD

; PB7/SCK/SCL	SCL/SCLK
; PB6/DO    	MISO
; PB5/DI/SDA	SDA/MOSI
; PB4/OC1B  	ChargePump_clock(1-2kHz)
; PB3/OC1A  	DB7-SW4-LED4
; PB2/OC0A  	DB6-SW3-LED3
; PB1       	DB5-SW2-LED2
; PB0       	DB4-SW1-LED1

#include	"common.inc"

#ifdef I2C_BUS_FAULT_CHECK
#	warning "enabling I2C_BUS_FAULT_CHECK... use fault counter on 2bytes of SRAM"
#endif

;	*****************  CONST *****************

;	*****************  TEXT  *****************
.section	.text
.align	1, 0xff
.org	0x0000
SYS_VECT:
	RJMP	RESET		; 0x00
	RJMP	EXT_INT0	; 0x01
	RJMP	EXT_INT1	; 0x02
	RJMP	TIM1_CAPT	; 0x03
	RJMP	TIM1_COMPA	; 0x04
	RJMP	TIM1_OVF	; 0x05
	RJMP	TIM0_OVF	; 0x06
	RJMP	USART_RXC	; 0x07
	RJMP	USART_UDRE	; 0x08
	RJMP	USART_TX	; 0x09
	RJMP	ANA_COMP	; 0x0a
	RJMP	PCINT		; 0x0b
	RJMP	TIM1_COMPB	; 0x0c
	RJMP	TIM0_COMPA	; 0x0d
	RJMP	TIM0_COMPB	; 0x0e
	RJMP	USI_START	; 0x0f
	RJMP	USI_OVF		; 0x10
	RJMP	WW_RDY		; 0x11
	RJMP	WDT_OVF		; 0x12

#ifdef STRinEEPROM
.section	.eeprom
.align	0
#else
.section	.text
.align	1, 0xff
#endif
VAR	STR_INIT_TOP
VAR	CHR_HEXADECIMAL
	.ascii	"0123456789ABCDEF"
VAR	STR_INIT_MES
	.asciz	"I2C I/O"
#if ( defined(TWIN_LCD) && !defined(I2C_LEDMATRIX))
VAR	STR_INIT_MES_ALT
	.asciz	"ALT LCD"
#endif /* TWIN_LCD */

.section	.eeprom
.align	0
VAR	STR_URL_OUR_SITE
	.asciz	"http://yesavr.web.fc2.com/tiny2313/AVR_I2C_IO/AVR_I2C_IO.html"

;	*****************  COMM  *****************
.section	.bss
.align	0

;	*****************  MISC  *****************
.section	.eeprom
.align	0

;	*****************  TEXT  *****************
.section	.text
.align	1, 0xff
; /*******************************************************************/
BEGIN	TIM0_COMPA	;; takes about 12-20 clks / every 1ms
	IN  	save_sreg, SREG       ; 1
	INC 	fcnt_1ms              ; 1

	SBI 	updateFLG, updateCNTms; 2

	AND 	dcnt_1ms, dcnt_1ms    ; 1
	BREQ	0f                    ; 1 / 2
	DEC 	dcnt_1ms              ; 1
0:

#ifdef dcnt_1ms_1
	AND 	dcnt_1ms_1, dcnt_1ms_1 ; 1
	BREQ	1f                    ; 1 / 2
	DEC 	dcnt_1ms_1            ; 1
1:
#endif /* dcnt_1ms_1 */

#ifdef dcnt_1ms_2
	AND 	dcnt_1ms_2, dcnt_1ms_2 ; 1
	BREQ	2f                    ; 1 / 2
	DEC 	dcnt_1ms_2            ; 1
2:
#endif /* dcnt_1ms_2 */

#ifdef dcnt_1ms_3
	AND 	dcnt_1ms_3, dcnt_1ms_3 ; 1
	BREQ	3f                    ; 1 / 2
	DEC 	dcnt_1ms_3            ; 1
	BRNE	3f                    ; 1 / 2

	SBIS	PINB, 7               ; 1 / 2,3
	RJMP	GOTO_RESET            ; 2 // leave SCL=L least 250ms to system reset

	SBI 	updateFLG, updateI2CI ; 2
	SBIC	PINB, 5               ; 1 / 2,3
	RJMP	3f                    ; 2 // leave SCL=H,SDA=H least 250ms to Idle state

;; disable_USI_START:
;; disable_USI_OVF:
	PUSH	r24
	OUT 	USICR, r24
	LDI 	r24,   0xe0
	OUT 	USISR, r24
#ifdef I2C_BUS_FAULT_CHECK
	LDS 	r24, I2C_SRAM+62
	INC 	r24
	STS 	I2C_SRAM+62, r24
#endif
	POP 	r24

	SBI 	updateFLG, updateI2CZ ; 2 // leave SCL=H,SDA=L least 250ms to USI reset

3:
#endif /* dcnt_1ms_3 */

	OUT 	SREG, save_sreg       ; 1
	RETI                          ; 4
ENDFN

; /*******************************************************************/
BEGIN	USART_RXC	;; takes about 10 clks
	IN  	save_sreg, SREG            ; 1
	IN  	UART_inc, UDR              ; 1
	SBI 	updateFLG, updateSCI       ; 2
	OUT 	SREG, save_sreg            ; 1
	RETI                               ; 4
ENDFN

;	*****************  delay sub-routines   *****************
BEGIN	_wait_ms	; void wait_ms(BYTE); // REG:r24
	MOV 	dcnt_1ms, r24
1:
	TST 	dcnt_1ms
	BRNE	1b
RETURN

;	*****************  SCI_display sub-routines   *****************
#if 0
BEGIN	_SCI_SPCOUT
	LDI 	r24, ' '
	RJMP	_SCI_putchr
ENDFN
BEGIN	_SCI_CRLFOUT
	LDI 	r24, '\r'
	RCALL	_SCI_putchr
	LDI 	r24, '\n'
	RJMP	_SCI_putchr
ENDFN
#endif

BEGIN _SCI_BYTEOUT ; void SCI_BYTEOUT(BYTE)
	MOV 	r25, r24
	SWAP	r24
	RCALL	_SCI_HEXOUT
	MOV 	r24, r25
ENDFN ; to be continued next
BEGIN _SCI_HEXOUT ; BYTE SCI_HEXOUT(BYTE)
	RCALL	_HEX2CHR
;	RJMP	_SCI_putchr
ENDFN ; to be continued next
BEGIN	_SCI_putchr	; void SCI_putchr(BYTE);
;	(r24Ƥ)
	SBIS	UCSRA, UDRE
	RJMP	_SCI_putchr	;Хåե˶ʤΥ롼
	OUT 	UDR, r24
RETURN

; /*******************************************************************/
EXT_INT0:
EXT_INT1:
TIM1_CAPT:
TIM1_COMPA:
TIM1_OVF:
TIM0_OVF:
;; USART_RXC:
USART_UDRE:
USART_TX:
ANA_COMP:
;; PCINT:
TIM1_COMPB:
;; TIM0_COMPA:
TIM0_COMPB:
;; USI_START:
;; USI_OVF:
WW_RDY:
WDT_OVF:

BEGIN	_CPU_HALT	; R.I.P. is here
	LDI 	r24, RAMEND
	OUT 	SPL, r24
	CLR 	r24
	OUT 	SREG, r24
	SLEEP
	RJMP	_CPU_HALT
ENDFN

BEGIN	GOTO_RESET
#ifdef I2C_BUS_FAULT_CHECK
	LDS 	r24, I2C_SRAM+63
	INC 	r24
	STS 	I2C_SRAM+63, r24
#endif
ENDFN
; /*******************************************************************/
;	initialize at reset
RESET:
	LDI 	r24, RAMEND
	OUT 	SPL, r24
	LDI 	r24,(1<<SE)	; PUEnable,SE=Idle@sleep
	OUT 	MCUCR, r24

; /*******************************************************************/
;  setup GPIO
BEGIN	INIT_GPIO
; Port-A : PA:=-----P11=11111111
	SER 	r24 	; PA1/XTAL2,PA0/XTAL1 set INPUT w/PU
	OUT 	PORTA, r24
	CLR 	r24
	OUT 	DDRA, r24

#ifndef TWIN_LCD
; Port-B : PB:=1PP11111=10011111
	SER 	r24
	OUT 	PORTB, r24
	LDI 	r24, 0x9f
	OUT 	DDRB, r24
#else
; Port-B : PB:=10P11111=11011111
	LDI 	r24, 0xbf
	OUT 	PORTB, r24
	LDI 	r24, 0xdf
	OUT 	DDRB, r24
#endif

; Port-D : PD:=-000P11P=01110110
	LDI 	r24, 0x0f
	OUT 	PORTD, r24
	LDI 	r24, 0x76
	OUT 	DDRD, r24
ENDFN

BEGIN	deinit_all_interrupt
	CLR 	r24
;; disable_USART_RXC:
	OUT 	UCSRA, r24
	OUT 	UCSRB, r24
	OUT 	UCSRC, r24
;; disable_PCINT:
	OUT 	PCMSK, r24
	OUT 	EIFR,  r24
;; disable_TIM0_COMPA:
	OUT 	TIMSK, r24
;; disable_USI_START:
;; disable_USI_OVF:
	OUT 	USICR, r24
	LDI 	r24,   0xe0
	OUT 	USISR, r24
ENDFN

; /*******************************************************************/
;  setup general
	CLR 	r24
	OUT 	TIMSK, r24
	OUT 	TIFR, r24

	LDX 	__bss_start

; /*******************************************************************/
;	Stop_AD:	; will stop ADC and Vref
	LDI 	r24, 0x90
	OUT 	ACSR, r24

; /*******************************************************************/
;  setup TIM0: COMP0A every 1ms(8MHz/64/125)
BEGIN	INIT_TIM0
	CLR 	r24
	OUT 	TCNT0, r24

	LDI 	r24, 124
	OUT 	OCR0A, r24

	LDI 	r24, 0x03	; 0000, WGM2=0, CSI2-0=011:clkIO/64
	OUT 	TCCR0B, r24

	LDI 	r24, 0x02	; OC0A=00:GPIO, OC0B=00:GPIO, 00, WGM11-10=10
	OUT 	TCCR0A, r24

	LDI 	r24, 0x01	; OCIE0A
	OUT 	TIMSK, r24
ENDFN

; /*******************************************************************/
;  setup TIM1: OC1B=toggle every 0.1ms (=8MHz/8/100)
BEGIN	INIT_TIM1
	CLR 	r24
	OUT 	TCNT1H, r24	; note set zero into TEMP
	OUT 	TCNT1L, r24

	OUT 	OCR1BL, r24	; note OCR1BH=TEMP=0

	LDI 	r24, 99	; TCNT1max
	OUT 	OCR1AL, r24	; note OCR1AH=TEMP=0

	LDI 	r24, 0x0a	; 000, WGM13-12=01, CSI2-0=010:clkIO/8
	OUT 	TCCR1B, r24

	LDI 	r24, 0x10	; OC1A=00:GPIO, OC1B=01:toggle, 00, WGM11-10=00
	OUT 	TCCR1A, r24
ENDFN

; /*******************************************************************/
;  setup UART
BEGIN	INIT_UART
	CLR 	r24
	OUT 	UCSRB, r24  ; disable USART

	LDI 	r24,hi8(BRR_VAL)
	OUT 	UBRRH, r24
	LDI 	r24,lo8(BRR_VAL)
	OUT 	UBRRL, r24

	LDI 	r24, 0x62	; USCRA<= U2X on
	OUT 	UCSRA, r24
	LDI 	r24, 0x98	; USCRB<= RXCIE,RXEN,TXEN
	OUT 	UCSRB, r24
	LDI 	r24, 0x06	; USCRC<= UCSZ1,UCSZ0(8n1)
	OUT 	UCSRC, r24
ENDFN

; /*******************************************************************/
;  setup PCINT7: interruption by PB7(SCL) pin edge trigger
BEGIN	INIT_PCINT7
	LDI 	r24, 0x80
	OUT 	PCMSK, r24
	LDI 	r24, 0xe0
	OUT 	EIFR, r24
	LDI 	r24, 0x20
	OUT 	GIMSK, r24
ENDFN

#ifdef dcnt_1ms_3
	CLR 	dcnt_1ms_3              ; 1
#endif

; /*******************************************************************/
;  enable Interrupts
	CLR 	r24
	OUT 	TIFR, r24
; *** clear flags
	OUT 	updateFLG, r24
; *** enable interrupts
	SEI


; *** initializing external peripherrals
	RCALL	_CLCD_init
	LDI 	r24, STR_INIT_MES
	RCALL	_CLCD_puts
#if (defined(TWIN_LCD) && !defined(I2C_LEDMATRIX))
	LDI 	CLCD_NO, 1
	LDI 	r24, STR_INIT_MES_ALT
	RCALL	_CLCD_puts
	CLR 	CLCD_NO
#endif /* TWIN_LCD && !I2C_LEDMATRIX */

	RCALL	_start
	RJMP	RESET
;	RJMP	_CPU_HALT

; /*******************************************************************/
;  PCINT7 ISR
BEGIN PCINT ; // for robastness
	IN  	save_sreg, SREG         ; 1
#ifdef dcnt_1ms_3
	CLR 	dcnt_1ms_3              ; 1
	COM 	dcnt_1ms_3              ; 1
	OUT 	SREG, save_sreg         ; 1
#endif
	RETI                            ; 4
ENDFN



