; 10main.S
;  main loop
; refer to http://yesavr.web.fc2.com/tiny2313/AVR_I2C_IO/AVR_I2C_IO.html

; /*******************************************************************/
#include	"common.inc"


;	*****************  COMM  *****************
.section	.bss
.align	0
#ifdef I2C_ADDR_EEPROM
VAR	I2C_SRAM
	.space	64
VAR	I2C_EPROM_ADDR
	.space	2
#endif
#if ( defined(TWIN_LCD) && !defined(I2C_LEDMATRIX))
VAR	USART_ON_ALT
	.space	1
#endif /* TWIN_LCD */


;	*****************  TEXT  *****************
.section	.text
.align	1, 0xff

BEGIN	_start
; /*******************************************************************/
#if ( defined(TWIN_LCD) && !defined(I2C_LEDMATRIX))
#  ifdef USART_ON_ALT_LCD
	LDI 	CLCD_NO, 1
#  else
	CLR 	CLCD_NO
#  endif
	STS 	USART_ON_ALT, CLCD_NO
#endif /* TWIN_LCD */

#if ( defined(I2C_ADDR_EEPROM) && defined(I2C_LEDMATRIX) )
; clear I2C_SRAM for LEDmatrix frame buffer
	RCALL	LEDMATRIX_setup
#endif /* I2C_ADDR_EEPROM  &&  I2C_LEDMATRIX */

;  do setup USI flag
	SBI 	updateFLG, updateI2CZ ; 2

	LDI 	r24, 0xc0
	RCALL	_CLCD_cmd

	CLR 	ALT_I2C_EOR_MASK
	RCALL	LEDCHECK	// for LAMP TEST
	ANDI	r24,0x0f
	SWAP	r24
	MOV 	ALT_I2C_EOR_MASK, r24 ; set I2C_slave inverse-bits mask
	AND 	ALT_I2C_EOR_MASK, ALT_I2C_EOR_MASK
	BREQ	g_loop

// display SWstatus if any SW pushed
//	SWAP	r24
//	RCALL	_SCI_HEXOUT  // echo to SCI in hexadecimal

	LDI 	r30, 7
	MOV 	r31, ALT_I2C_EOR_MASK
1:
	LDI 	r24, '0'
	SBRC	r31, 7
	ORI 	r24, 1
	RCALL	_CLCD_dat ; // r22-25
	LSL 	r31
	DEC 	r30
	BRNE	1b
	LSR 	ALT_I2C_EOR_MASK

; ************************************* MAIN LOOP
g_loop:
	sleep

#if 0
	OUT 	LEDOUT, USI_STAT
//	OUT 	LEDOUT, updateFLG
	RCALL	_SW_LED
	CPI 	r24, 0x11
	BRNE	99f
	MOV 	r24, USI_STAT
	RCALL	_SCI_BYTEOUT
	LDI 	r24, '='
	RCALL	putchar
//	MOV 	r24, updateFLG

//	MOV 	r24, ALT_I2C_EOR_MASK
	LDS 	r24, I2C_EPROM_ADDR
	RCALL	_SCI_BYTEOUT
	LDI 	r24, ' '
	RCALL	putchar
99:
#endif

	SBIC	updateFLG, updateSCI
	RCALL	UART_proc

	SBIC	updateFLG, updateI2CS
	RCALL	I2C_USR_PROC_READ
	SBIC	updateFLG, updateI2CR
	RCALL	I2C_USR_PROC_WRITE

	SBIC	updateFLG, updateI2CZ
	RCALL	_INIT_USI
	SBIC	updateFLG, updateI2CI
	RCALL	_IDLE_USI

#if ( defined(I2C_ADDR_EEPROM) && defined(I2C_LEDMATRIX) )
	SBIC	updateFLG, updateCNTms
	RCALL	LEDMATRIX_proc
#endif /* I2C_ADDR_EEPROM  &&  I2C_LEDMATRIX */

	CBI 	updateFLG, updateCNTms

	RCALL	USI_stop_check

	AND 	dcnt_1ms_2, dcnt_1ms_2
	BRNE	g_loop
	MOV 	r24, USI_STAT
	COM 	r24
	BRNE	g_loop

	RCALL	_INIT_USI

#if 0
	AND 	dcnt_1ms, dcnt_1ms
	BRNE	g_loop

	RCALL	_SW_LED
	LDI 	r24, 19
	MOV 	dcnt_1ms, r24
#endif
	RJMP	g_loop

ENDFN

; ************************************* LED_CHECK
BEGIN	LEDCHECK
	LDI 	r24, 1
0:
	OUT 	LEDOUT, r24
	RCALL	_SW_LED

	CLR 	dcnt_1ms
	DEC 	dcnt_1ms
	MOV 	r20, dcnt_1ms
1:
	CP  	r20, dcnt_1ms
	BREQ	2f
	RCALL	_SW_LED
	MOV 	r20, dcnt_1ms
2:
	AND 	dcnt_1ms, dcnt_1ms
	BRNE	1b

	IN  	r24, LEDOUT
	LSL 	r24
	ANDI	r24, 0x0f
	BRNE	0b

	OUT 	LEDOUT, r24
	RCALL	_SW_LED
RETURN

; ************************************* END

#if 0
 XX   XX
  X   X
  XX XX
  XX XX   XXXXX  XXX X    XXXXX
  X X X  X     X  X X X  X     X
  X X X  XXXXXXX  X X X  X     X
  X   X  X        X X X  X     X
  X   X  X     X  X X X  X     X
 XXX XXX  XXXXX  XX X XX  XXXXX

s:start condition
p:stop condition
1,0:master send a constatnt bit
x: master send a bit
H,L:slave send a constant bit
X: slave send a bit
a,n: master reply acknowledge/NAK
A,N: slave reply acknowledge/NAK

Data format:

4LED/4BTN CTRL
ܥ/LEDּ/⡼
s 10100100A ****xxxxA p
  addr=0x52 write LED status

s 10100101A XXXXXXXXa p
  addr=0x52 read LED/BTN status(LED:=upper_nibble, BTN:=lower_nibble)


Native LCD control
s 10100010A xxxxxxxxA xxxxxxxxA ... p
s 10100010A xxxxxxxxA p
  addr=0x51 write LCD RS=L(command) Bytes

s 10100011A XXXXXXXXa p
s 10100011A XXXXXXXXn p
  addr=0x51 read LCD RS=L(status) Byte


Native LCD data transfer
s 10100110A xxxxxxxxA xxxxxxxxA ... p
s 10100110A xxxxxxxxA p
  addr=0x53 write LCD RS=H(CGRAM/DDRAM) Bytes

s 10100111A XXXXXXXXa XXXXXXXXa ... p
s 10100111A XXXXXXXXa p
s 10100111A XXXXXXXXn p
  addr=0x53 read LCD RS=H(CGRAM/DDRAM) Bytes


I2CLCDѥ饤ȥ⡼
slave addr=0x50(write only)
CTRLbyte:
CTRL byte:= 0x00:CMD,0x80:DATA
CMD/DATA byte

s 10100000A x0000000A xxxxxxxxA p
            ^R/S bit  data

I2CLCDѥ饤ȥ⡼
slave addr=0x3e(write only)
CTRLbyte:
CTRL byte:= 0x00:CMD,0x40:DATA,0x80:Continous other command >> for detail see ST7032i datasheet
CMD/DATA byte

s 10100000A 1x000000A xxxxxxxxA p
s 10100000A 0x000000A xxxxxxxxA xxxxxxxxA ... p
s 10100000A 1x000000A xxxxxxxxA 0x000000A xxxxxxxxA xxxxxxxxA ... p
s 10100000A 0x000000A xxxxxxxxA xxxxxxxxA ... p
            ^ Co,R/S bit data

I2CLCDĥ꡼ɥ⡼
(I2CLCDĥ꡼ɥ⡼ɤƱ)
slave addr=0x50(read)
STATUSbyte:
DATAbyte:

s 10100001A XXXXXXXXa XXXXXXXXa ... p
s 10100001A XXXXXXXXa XXXXXXXXn p
s 10100001A XXXXXXXXn p
            ^statusByte ^DDRAM/CGRAMdata ...


Port description:
#define NAK 	SBI 	PORTB, 5
#define ACK 	CBI 	PORTB, 5

SCL ~~~|___|~~|__|~~|__|~~|__|~~|__|~~|__|~~|__|~~|__|~~|__

SDA ~|___X==A6=X==A5=X==A4=X==A3=X==A2=X==A1=X==A0=X=R/W=x
*    S 0   1  2  3  4  5  6  7  8  9  10 11 12 13 14 15 ov


State machines:
	To Be Determined


StartCondition:
	SDAin
	STAT=1
	enOVF
	cnt=0

OVF:
	STAT==1: (AddressRecv)
		is matched addr:
			SDAout
			SDA=L
			TEMPADDR=USIDR
			STAT=2,cnt=14
		not matched:
			STAT=0
	STAT==2: (AddressACK)
		cnt=0
		SDA=F
		TEMPADDR & 1==1: (MaseterReadFromSlave)
			SDAout
			STAT=4
			reqSEND=1;
			SCL=L
		TEMPADDR & 1==0: (MaseterWriteToSlave)
			SDAin
			STAT=6
			Received!=0:
				SCL=L
	STAT==4: (DataSend)
		cnt=14
		STAT=5
		SDAin
	STAT==5: (DataCHK)
		cnt=0
		USIDR & 1==1: // NAK received
			STAT= 0
		USIDR & 1==0: // ACK received
			SDAout
			STAT=4
			reqSEND=1;
			SCL=L
	STAT==6: (DataRecv)
		Received=1
		USI_DATA=USIDR
		cnt=14
		STAT=7
		SDAout
		SDA=L
	STAT==7: (DataACK)
		cnt=0
		SDAin
		SDA=F
		STAT=6
		Received!=0:
			SCL=L

DATA_SEND:
	STAT=4:
		USIDR= r24
		SCL=F
		reqSEND=0
DATA_RECV:
	STAT=6||=7:
		r24= USI_DATA
		SCL=F
		Received=0


#endif
