; 11usart_proc.S
;  usart process
; refer to http://yesavr.web.fc2.com/tiny2313/AVR_I2C_IO/AVR_I2C_IO.html

; /*******************************************************************/
#include	"common.inc"


;	*****************  COMM  *****************
.section	.bss
.align	0
;	*****************  TEXT  *****************
.section	.text
.align	1, 0xff

; ************************************* USART I/O
BEGIN	UART_proc
	MOV 	r24, UART_inc
	CBI 	updateFLG, updateSCI

#if ( defined(TWIN_LCD) && !defined(I2C_LEDMATRIX))
	CLR 	CLCD_NO
	CPI 	r24, 0xfe
	BREQ	101f
	CPI 	r24, 0xa0
	BRNE	102f
	LDI 	CLCD_NO, 1
101:
	STS 	USART_ON_ALT, CLCD_NO
	RET

102:
	LDS 	CLCD_NO, USART_ON_ALT
#else
	CPI 	r24, 0xfe
	BREQ	101f
	CPI 	r24, 0xa0
	BRNE	102f
101:
	RET
102:
#endif /* TWIN_LCD */

	CPI 	r24, 0x20
	BRCC	98f
0:
	CPI 	r24, 0x0a  ; LF=cursor change line
	BRNE	1f
	RCALL	_CLCD_rd_stat
	LDI 	r25, 0x40
	EOR 	r24, r25
10:
	ORI 	r24, 0x80
	RJMP	_CLCD_cmd

1:
	CPI 	r24, 0x0d  ; CR=cursor to head of line
	BRNE	2f
	RCALL	_CLCD_rd_stat
	ANDI	r24, 0xc0
	RJMP	10b

2:
	CPI 	r24, 0x0b  ; HM=cursor to home-pos.
	BRNE	3f
	LDI 	r24, 0x0c  ; display ON/cursor off/blink off
	RCALL	_CLCD_cmd
	LDI 	r24, 0x80
	RJMP	10b

3:
	CPI 	r24, 0x0f  ; get SW_STAT
	BRNE	4f
	IN  	r24, SW_STAT
//	RJMP	_SCI_BYTEOUT
	RJMP	_SCI_HEXOUT

4:
	CPI 	r24, 0x08  ; BS=move cursor to left
	BRNE	5f
	RCALL	_CLCD_rd_stat
	ANDI	r24, 0x7f
	BREQ	9f
	DEC 	r24
	RJMP	10b

5:
	CPI 	r24, 0x09  ; VT=move cursor to right
	BRNE	6f
	LDI 	r24, 0x14
	RJMP	_CLCD_cmd

6:
	CPI 	r24, 0x0c  ; HT=cls
	BRNE	7f
#if 0
	MOV 	r24, USI_STAT
	RCALL	_SCI_BYTEOUT
	MOV 	r24, USISR
	RCALL	_SCI_BYTEOUT
#endif
	LDI 	r24, 0x0c  ; display ON/cursor off/blink off
	RCALL	_CLCD_cmd
	LDI 	r24, 1     ; clear DDRAM
	RJMP	_CLCD_cmd

7:
	MOV 	r25, r24
	ANDI	r25, 0xf0
	CPI 	r25, 0x10
	BRNE	8f
	ANDI	r24, 0x0f
	OUT 	LEDOUT, r24
	RJMP	_SW_LED

8:
	CPI 	r24, 0x0e  ; HT=cls
	BRNE	98f
	LDI 	r24, 0x0f  ; display ON/cursor off/blink off
	RJMP	_CLCD_cmd

98:
	RJMP	_CLCD_dat

9:
RETURN

