; 12usr_proc.S
;  user process
; refer to http://yesavr.web.fc2.com/tiny2313/AVR_I2C_IO/AVR_I2C_IO.html

; /*******************************************************************/
#include	"common.inc"


;	*****************  COMM  *****************
.section	.bss
;	*****************  TEXT  *****************
.section	.text
.align	1, 0xff

; ************************************* I2C READ (Master read from Slave)

BEGIN	I2C_USR_PROC_READ
; I2C Master read from Slave
#ifdef TWIN_LCD
	CLR 	CLCD_NO
#endif
	MOV 	r24, USI_ADDRW
	LSR 	r24
	EOR 	r24, ALT_I2C_EOR_MASK
#ifdef	I2C_ADDR_LCDDAT
	CPI 	r24, I2C_ADDR_LCDDAT
	BREQ	lcd_datr
#endif
#ifdef	I2C_ADDR_LCDCMD
	CPI 	r24, I2C_ADDR_LCDCMD
	BREQ	lcd_sta
#endif
#ifdef	I2C_ADDR_BTNLED
	CPI 	r24, I2C_ADDR_BTNLED
	BREQ	led_btn_stat
#endif
#ifdef	I2C_ADDR_EEPROM
	CPI 	r24, I2C_ADDR_EEPROM
	BREQ	i2c_eepromr
#endif
#ifdef	I2C_ADDR_AKILCD
	CPI 	r24, I2C_ADDR_AKILCD
	BREQ	aki_lcd_status
#endif
#ifdef	I2C_ADDR_15LCD
	CPI 	r24, I2C_ADDR_15LCD
	BREQ	aki_lcd_status
#endif

#if ( defined(TWIN_LCD) && !defined(I2C_LEDMATRIX))
	LDI 	CLCD_NO, 1
#  ifdef	I2C_ADDR_LCDDAT_ALT
	CPI 	r24, I2C_ADDR_LCDDAT_ALT
	BREQ	lcd_datr
#  endif
#  ifdef	I2C_ADDR_LCDCMD_ALT
	CPI 	r24, I2C_ADDR_LCDCMD_ALT
	BREQ	lcd_sta
#  endif
#  ifdef	I2C_ADDR_AKILCD_ALT
	CPI 	r24, I2C_ADDR_AKILCD_ALT
	BREQ	aki_lcd_status
#  endif
	CLR 	CLCD_NO
#endif /* TWIN_LCD */
	RET


; 15LCD
; AKI-LCD
aki_lcd_status:
	AND 	EXT_LCD_STAT, EXT_LCD_STAT
	BRNE	akilcd_datar
	LDI 	r25, EXT_LCD_STAT_AKIFLAG | EXT_LCD_STAT_CMD
	MOV 	EXT_LCD_STAT, r25
	RET

akilcd_datar:
	MOV 	r25, EXT_LCD_STAT
	ANDI	r25, EXT_LCD_STAT_DAT
	BRNE	lcd_datr
	LDI 	r25, EXT_LCD_STAT_AKIFLAG | EXT_LCD_STAT_DAT
	MOV 	EXT_LCD_STAT, r25

; LCD-STATUS
lcd_sta:
	RCALL	_CLCD_rd_stat
	RCALL	_SEND_USI	;; void SEND_USI(uint8_t data); // r24-25
	RET

; LCD-DATAR
lcd_datr:
	RCALL	_CLCD_rd_data
	RCALL	_SEND_USI	;; void SEND_USI(uint8_t data); // r24-25
	RET

; LED&BTN-STATUS
led_btn_stat:
	RCALL	_SW_LED
	ANDI	r24, 0x0f
	IN  	r25, LEDOUT
	ANDI	r25, 0x0f
	SWAP	r25
	OR  	r24, r25
	RCALL	_SEND_USI	;; void SEND_USI(uint8_t data); // r24-25
9:
RETURN


#ifdef I2C_ADDR_EEPROM
BEGIN	i2c_eepromr
	LDS 	r25, I2C_EPROM_ADDR
	ANDI	r25, 0x80
	BRNE	I2C_NVSRAMR
I2C_EEPROMR:
	LDS 	r25, I2C_EPROM_ADDR
	ANDI	r25, 0x7f
	OUT 	EEAR, r25
	SBI 	EECR, EERE
	IN  	r24, EEDR
	INC 	r25
	ANDI	r25, 0x7f
	RJMP	9f

I2C_NVSRAMR:
	LDS 	r25, I2C_EPROM_ADDR
	ANDI	r25, 0x3f
	LDZ 	I2C_SRAM
	ADDZ	r25
	LD  	r24, Z
	INC 	r25
	ANDI	r25, 0x3f
	ORI 	r25, 0x80
9:
	STS 	I2C_EPROM_ADDR, r25
	RCALL	_SEND_USI	;; void SEND_USI(uint8_t data); // r24-25
RETURN

BEGIN	i2c_eepromw
#if 0
	push	r24
	mov 	r24, EXT_LCD_STAT
	RCALL	_SCI_BYTEOUT
	pop 	r24
#endif
	AND 	EXT_LCD_STAT, EXT_LCD_STAT
	BRNE	2f
	STS 	I2C_EPROM_ADDR, r24
	INC 	EXT_LCD_STAT
	CLR 	r24
	RJMP	19f

1: // for more than 8 addressing
	MOV 	r25, EXT_LCD_STAT
	CPI 	r25, 1
	BRNE	2f
19:
	STS 	I2C_EPROM_ADDR+1, r24
	INC 	EXT_LCD_STAT
	RET

2:
	LDS 	r25, I2C_EPROM_ADDR
	ANDI	r25, 0x80
	BRNE	I2C_NVSRAMW
I2C_EEPROMW:
	SBIC	EECR, EEPE
	RJMP	I2C_EEPROMW
	LDS 	r25, I2C_EPROM_ADDR
	ANDI	r25, 0x7f
	OUT 	EEAR, r25
	OUT 	EEDR, r24
	SBI 	EECR, EEMPE
	SBI 	EECR, EEPE
	INC 	r25
	ANDI	r25, 0x7f
	RJMP	9f

I2C_NVSRAMW:
	LDS 	r25, I2C_EPROM_ADDR
	ANDI	r25, 0x3f
	LDZ 	I2C_SRAM
	ADDZ	r25
	ST  	Z, r24
	INC 	r25
	ANDI	r25, 0x3f
	ORI 	r25, 0x80
9:
	STS 	I2C_EPROM_ADDR, r25
RETURN
#endif

; ************************************* I2C WRITE(Master write to Slave)

BEGIN	I2C_USR_PROC_WRITE
; I2C Master write to Slave
	RCALL	_RECV_USI	;; uint8_t RECV_USI(void); // r24-25
#ifdef TWIN_LCD
	CLR 	CLCD_NO
#endif

#if 0
	RCALL	I2C_USR_PROC_WRITE_PRINT
#endif
	MOV 	r25, USI_ADDRW
	LSR 	r25
	EOR 	r25, ALT_I2C_EOR_MASK
#ifdef	I2C_ADDR_LCDDAT
	CPI 	r25, I2C_ADDR_LCDDAT
	BREQ	lcd_datw
#endif
#ifdef	I2C_ADDR_LCDCMD
	CPI 	r25, I2C_ADDR_LCDCMD
	BREQ	lcd_cmd
#endif
#ifdef	I2C_ADDR_BTNLED
	CPI 	r25, I2C_ADDR_BTNLED
	BREQ	led_out
#endif
#ifdef	I2C_ADDR_EEPROM
	CPI 	r25, I2C_ADDR_EEPROM
	BREQ	i2c_eepromw
#endif
#ifdef	I2C_ADDR_AKILCD
	CPI 	r25, I2C_ADDR_AKILCD
	BREQ	akilcd
#endif
#ifdef	I2C_ADDR_15LCD
	CPI 	r25, I2C_ADDR_15LCD
	BREQ	ichigo_wrt
#endif

#if ( defined(TWIN_LCD) && !defined(I2C_LEDMATRIX))
	LDI 	CLCD_NO, 1
#  ifdef	I2C_ADDR_LCDDAT_ALT
	CPI 	r25, I2C_ADDR_LCDDAT_ALT
	BREQ	lcd_datw
#  endif
#  ifdef	I2C_ADDR_LCDCMD_ALT
	CPI 	r25, I2C_ADDR_LCDCMD_ALT
	BREQ	lcd_cmd
#  endif
#  ifdef	I2C_ADDR_AKILCD_ALT
	CPI 	r25, I2C_ADDR_AKILCD_ALT
	BREQ	akilcd
#  endif
	CLR 	CLCD_NO
#endif /* TWIN_LCD */
	RET


; 15LCD
ichigo_wrt:
	SBRC	EXT_LCD_STAT, 3
	RJMP	ichigoout

	SWAP	r24
	LSR 	r24
	LSR 	r24
	ANDI	r24, 0x03
	ORI 	r24, EXT_LCD_STAT_15FLAG
	MOV 	EXT_LCD_STAT, r24
	RET

ichigoout:
	MOV 	r25, EXT_LCD_STAT
	SBRC	EXT_LCD_STAT, 1
	CLR 	EXT_LCD_STAT	; clear stat if set cont-bit

	ANDI	r25, EXT_LCD_STAT_DAT
	BRNE	lcd_datw
	RJMP	lcd_cmd


; AKI-LCD
akilcd:
	SBRC	EXT_LCD_STAT, 2
	RJMP	akiout

	LDI 	r25, EXT_LCD_STAT_AKIFLAG
	SBRC	r24, 7 // check R/S bit
	ORI 	r25, EXT_LCD_STAT_DAT
	MOV 	EXT_LCD_STAT, r25
	RET
akiout:
	SBRS	EXT_LCD_STAT, 0
	RJMP	lcd_cmd

; LCD-DATAW
lcd_datw:
	RCALL	_CLCD_dat
#if 0
	LDI 	r24,'d'
	RCALL	putchar
#endif
	RET

; LCD-CMD
lcd_cmd:
	RCALL	_CLCD_cmd
#if 0
	LDI 	r24,'c'
	RCALL	putchar
#endif
	RET


; LED-OUT
led_out:
	CPI 	r24, 'R' ; 0x52
	BRNE	1f
	IN  	r25, LEDOUT
	CPI 	r25, '/' ; is prevoius 0x4F
	BRNE	1f
	CLR 	r31
	CLR 	r30
	IJMP	;; jump to RESET vector
1:
	OUT 	LEDOUT, r24
	RJMP	_SW_LED
i2c_usr_proc_write_exit:
RETURN

