; 14ledmatrix_proc.S
;  LED matrix display process
; refer to http://yesavr.web.fc2.com/tiny2313/AVR_I2C_IO/AVR_I2C_IO.html

; /*******************************************************************/
#include	"common.inc"
#ifdef I2C_ADDR_EEPROM
#ifdef I2C_LEDMATRIX

// see Memo at bottom of this file
//#define	LEDMATRIX_BITMAP_INVERSE_ORDER
//#undef	LEDMATRIX_BITMAP_INVERSE_ORDER

;	*****************  COMM  *****************
.section	.bss
.align	0
VAR	LEDMATRIX_CNT
	.space 1

;	*****************  TEXT  *****************
.section	.text
.align	1, 0xff

; ************************************* LED MATRIX OUT
BEGIN	LEDMATRIX_proc

	LEDMATRIX_ENA

	LDS 	r24, LEDMATRIX_CNT
	ANDI	r24, 0x0f
	LDZ 	I2C_SRAM
	ADDZ	r24

#ifndef	LEDMATRIX_BITMAP_INVERSE_ORDER
	LDD 	r23,Z + 0x30 ; for Sin3 data
	LDD 	r22,Z + 0x10 ; for Sin2 data
#else
	LDD 	r23,Z + 0x00 ; for Sin3 data
	LDD 	r22,Z + 0x20 ; for Sin2 data
#endif


; // TOP HALF of LED MATRIX

	SUBI	r24, -8
	COM 	r24
	ANDI	r24, 0x0f

	LDI 	r25, 8
10:
	CLEAR_PORT r21
	ROR 	r23
	BRCC	11f
	LEDMATRIX_SIN3_H
11:
12:

	ROR 	r22
	BRCC	13f
	LEDMATRIX_SIN2_H
13:
14:

	DEC 	r25
	CP  	r24,r25
	BRNE	15f
	LEDMATRIX_SIN1_H
15:
16:

	LEDMATRIX_CLOCK_H
	AND 	r25,r25
	BRNE	10b

; // BOTTOM HALF of LED MATRIX
#ifndef	LEDMATRIX_BITMAP_INVERSE_ORDER
	LDD 	r23,Z + 0x20 ; for Sin3 data
	LDD 	r22,Z + 0x00 ; for Sin2 data
#else
	LDD 	r23,Z + 0x10 ; for Sin3 data
	LDD 	r22,Z + 0x30 ; for Sin2 data
#endif

	SUBI	r24, -8
	ANDI	r24, 0x0f

	LDI 	r25, 8
20:
	CLEAR_PORT r21
	ROR 	r23
	BRCC	21f
	LEDMATRIX_SIN3_H
21:
22:

	ROR 	r22
	BRCC	23f
	LEDMATRIX_SIN2_H
23:
24:

	DEC 	r25
	CP  	r24,r25
	BRNE	25f
	LEDMATRIX_SIN1_H
25:
26:

	LEDMATRIX_CLOCK_H
	AND 	r25,r25
	BRNE	20b


	LEDMATRIX_LATCH_L
	LDS 	r24, LEDMATRIX_CNT
	INC 	r24
	STS 	LEDMATRIX_CNT, r24
	LEDMATRIX_LATCH_H

	LEDMATRIX_DIS

RETURN

BEGIN	LEDMATRIX_setup
	CLR 	r24
#ifdef I2C_BUS_FAULT_CHECK
	LDI 	r25, 62
	LDX 	I2C_SRAM+62
	LDZ 	I2C_LEDMATRIX_INITIAL_DATA_END-2
#else
	LDI 	r25, 64
	LDX 	I2C_SRAM+64
	LDZ 	I2C_LEDMATRIX_INITIAL_DATA_END
#endif
10:
	SUBI	ZL, 1
	BRCC	11f
	DEC 	ZH
11:
	LPM 	r24, Z
	ST  	-X, r24
	DEC 	r25
	BRNE	10b
RETURN



VAR	I2C_LEDMATRIX_INITIAL_DATA
#if 1
#	ifndef	LEDMATRIX_BITMAP_INVERSE_ORDER
; I2C I/O dot matrix data NORMAL ORDER
	.byte	0x00,0x76,0x29,0x22,0x24,0x2F,0x20,0x70
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x1C,0x22,0x40,0x40,0x40,0x22,0x1C
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x70,0x20,0x21,0x22,0x24,0x28,0x70,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x18,0xA4,0x42,0x42,0x42,0x24,0x18,0x00
#	else
; I2C I/O dot matrix data INVERSE ORDER
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x18,0xA4,0x42,0x42,0x42,0x24,0x18,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x70,0x20,0x21,0x22,0x24,0x28,0x70,0x00
	.byte	0x00,0x1C,0x22,0x40,0x40,0x40,0x22,0x1C
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x76,0x29,0x22,0x24,0x2F,0x20,0x70
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
#	endif
#else
; Blank data
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
#endif
VAR	I2C_LEDMATRIX_INITIAL_DATA_END
	NOP
#endif /* I2C_LEDMATRIX */
#endif /* I2C_ADDR_EEPROM */



#if 0 /* Memo */

[NORMAL_ORDER]:= ! defined(LEDMATRIX_BITMAP_INVERSE_ORDER)
Bitmap layout:
SRAM-
 addr:  +0x00    +0x10    +0x20    +0x30
+0x00: 76543210 76543210 76543210 76543210
+0x01: 76543210 76543210 76543210 76543210
  :
+0x0f: 76543210 76543210 76543210 76543210


[INVERSE_ORDER]:= defined(LEDMATRIX_BITMAP_INVERSE_ORDER)
Bitmap layout:
SRAM-
 addr:  +0x30    +0x20    +0x10    +0x00
+0x00: 76543210 76543210 76543210 76543210
+0x01: 76543210 76543210 76543210 76543210
  :
+0x0f: 76543210 76543210 76543210 76543210


 Sin1 | Sin2            | Sin3            |
   f   0123456789abcedf  0123456789abcdef
   e
   :
   0

initial bitmap
76543210 76543210 76543210 76543210
 @@@ @@     @@@    @@@        @@
  @ @  @   @   @    @      @ @  @
  @   @   @         @    @  @    @
  @  @    @         @   @   @    @
  @ @@@@  @         @  @    @    @
  @        @   @    @ @      @  @
 @@@        @@@    @@@        @@

0x76     0x1C     0x70     0x18
0x29     0x22     0x20     0xA4
0x22     0x40     0x21     0x42
0x24     0x40     0x22     0x42
0x2F     0x40     0x24     0x42
0x20     0x22     0x28     0x24
0x70     0x1C     0x70     0x18


#endif /* Memo */

