; 20sub.S
; LCD-clock w/RTC control subroutines
;
#include	"common.inc"

#define	WK_SIZ	6

;	*****************  CONST *****************
.section	.eeprom
.align	0

;	*****************  COMM  *****************
.section	.bss
.align	0

;	*****************  TEXT  *****************
.section	.text
.align	1, 0xff

;	*****************  LED_SW/LCD control sub-routines   *****************
// PB7=SCL,PB5=SDA, PB6=MISO(in),PB4=OC1B(out), PB3-0(out)
// default DDRB is	0xbf
BEGIN _BUS_RD	; work r25
	IN  	r25, DDRB
	ANDI	r25, 0xf0
	OUT 	DDRB, r25
RETURN
BEGIN _BUS_WR	; work r25
	IN  	r25, DDRB
	ORI 	r25, 0x0f
	OUT 	DDRB, r25
RETURN

#if 0
;	*****************  generic sub-routines   *****************
BEGIN _divmod	; r24 % r22 => div in r24, remain in r25 , work r23
	CLR 	r25
	LDI 	r23, 1
	CLC
1:
	ROL 	r24
	ROL 	r25
	CP  	r25, r22
	BRCS	2f
	SUB 	r25, r22
	INC 	r24
2:
	LSL 	r23
	BRNE	1b
RETURN

BEGIN _incDEC	; increment r24 in BINARY coded decimal
	INC 	r24
	MOV 	r25, r24
	ANDI	r25, 0x0f
	CPI 	r25, 0x0a
	BRCS	1f
	SUBI	r24, -6
1:
	MOV 	r25, r24
	ANDI	r25, 0xf0
	CPI 	r25, 0xa0
	BRCS	2f
	SUBI	r24, -0x60
2:
RETURN
#endif

BEGIN _HEX2CHR ; BYTE HEX2CHR(BYTE)	; r24
	ANDI	r24, 0x0f
	NEG 	r24
	SUBI	r24, CHR_HEXADECIMAL
	NEG 	r24
ENDFN ; to be continue next
BEGIN _GET_const_STR ; BYTE GET_const_STR(BYTE)	; r24
#ifdef STRinEEPROM
	OUT 	EEAR, r24
	SBI 	EECR, EERE
	IN  	r24, EEDR
#else
	CLR 	ZH
	MOV 	ZL, r24
	LPM 	r24, Z
#endif
RETURN

#if 0
BEGIN	i2a	; r24 -> (Y)=string, r21=#of digits, work:r25-r20
	LDS 	r20, plus_sign
	CLR 	r21 	; count of digits
	LDI 	r22, 10	; base radix
	LDY 	STR_wk
	ADIW	r28, WK_SIZ
	CLR 	r1
	ST  	-Y, r1	; put a terminator
	CPI 	r24, 0x80
	BRCS	12f
11:
	LDI 	r20, '-'
	NEG 	r24
12:
	RCALL	_divmod ; r24/r22 = r24 ... r25
	PUSH	r24
	MOV 	r24, r25
	RCALL	_HEX2CHR
	ST  	-Y, r24	; put a digit
	INC 	r21
	POP 	r24
	TST 	r24
	BRNE	12b

	ST  	-Y, r20	; put a sign
	INC 	r21
RETURN
#endif

.end
