; CLCD.S Text-LCD handler for HD44780 controller(4bit bus)
; refer to http://yesavr.web.fc2.com/tiny2313/AVR_I2C_IO/AVR_I2C_IO.html

#include	"common.inc"

;	*****************  TEXT  *****************
.section	.text
.align	1, 0xff

; CLCD_init() 饯LCD(ʲCLCD)νԤ
; CLCD_cmd(BYTE data) CLCD˥ޥɽϤԤ
; CLCD_dat(BYTE data) CLCD˥ǡϤԤ

; 쥸dcnt_CLCD(1msȤ˥ȥ󤹤)ˤꥦ椷Ƥ
; ǥեȤǥޥ/ǡϻdcnt_CLCD2ꤷơνϻ0ˤʤ
; ޤǥȤ(100us-200usΥߥ󥰤ݤ뤳ȤտޤƤ)
;
; ޥɤˤꥦȤĹ(ms)ȤˤϡѼ¦ǳޥ
; (ɽꥢۡ)ѻˤϡdcnt_TIM0Ŭͤꤹ뤫
; ޤӥ椹뤳ȡ
;
;  PB3..0 BTNLEDȷѤ4bitݡȤǤΤݡȤζαդ뤳ȡ
; (ؿϡ/¾бƤʤ!!)

BEGIN	_CLCD_rd_data	; BYTE CLCD_rd_data(void); // REG:r25-24
	SBI 	LCD_RS_PT	; RS=H
	RJMP	_CLCD_rd_nibbles
ENDFN

BEGIN	_CLCD_rd_stat	; BYTE CLCD_rd_stat(void); // REG:r25-24
	CBI 	LCD_RS_PT	; RS=L
ENDFN

BEGIN	_CLCD_rd_nibbles	; BYTE CLCD_rd_data(void); // REG:r25-24
	SW_LED_DI
	SBI 	LCD_RW_PT	; RW=H

	RCALL	_BUS_RD
	LCD_E_EN
	LDI 	r24, 4
1:	DEC 	r24
	BRNE	1b
	IN  	r25, PINB
	LCD_E_DI
	SWAP	r25
	ANDI	r25, 0xf0
	LCD_E_EN
	LDI 	r24, 4
2:	DEC 	r24
	BRNE	2b
	IN  	r24, PINB
	LCD_E_DI
	ANDI	r24, 0x0f
	OR  	r24, r25
	CBI 	LCD_RW_PT	; RW=L

	RCALL	_BUS_WR
	SW_LED_EN
RETURN


BEGIN	_CLCD_wr_nibble	; void CLCD_wr_nibble(BYTE); // REG:r24-22,Ref:r25
	SWAP	r24
	MOV 	r22, r25
	ANDI	r22, 0xf0
	MOV 	r23, r24
	ANDI	r23, 0x0f
	OR  	r23, r22
	OUT 	PORTB, r23
	LCD_E_EN
	LDI 	r22, 4
1:	DEC 	r22
	BRNE	1b
	LCD_E_DI
RETURN

BEGIN	_CLCD_cmd	; void CLCD_cmd_wait(BYTE); // REG:r25-22
	mov		r23, r24
	LDI 	r24, 3
	RCALL	_CLCD_wait_busy
	mov		r24, r23
ENDFN
BEGIN	_CLCD_cmd_nowait	; void CLCD_cmd(BYTE); // REG:r25-22
	CBI 	LCD_RS_PT	; RS=L
#ifndef ENABLE_8bit_bus_config	// for inhibit 8bit-bus config
	mov		r23, r24
	andi	r23, 0xe0
	cpi 	r23, 0x20
	BRNE	_CLCD_byte
	ANDI	r24, 0xef
#endif
	RJMP	_CLCD_byte
ENDFN

BEGIN	_CLCD_dat	; void CLCD_dat_wait(BYTE); // REG:r25-22
	mov		r23, r24
	LDI 	r24, 3
	RCALL	_CLCD_wait_busy
	mov		r24, r23
ENDFN
BEGIN	_CLCD_dat_nowait	; void CLCD_dat(BYTE); // REG:r25-22
	SBI 	LCD_RS_PT	; RS=H
ENDFN
BEGIN	_CLCD_byte  	; void CLCD_byte(BYTE); // REG:r25-22
	SW_LED_DI
	CBI 	LCD_RW_PT	; RW=L
	RCALL	_BUS_WR

	CLI
	IN  	r25, PORTB
	RCALL	_CLCD_wr_nibble
	RCALL	_CLCD_wr_nibble
	OUT 	PORTB, r25
	SEI

	SW_LED_EN
RETURN

BEGIN	_CLCD_wait_busy	; void CLCD_wait_busy(BYTE); // REG:r25-24
	MOV 	dcnt_CLCD, r24
1:
	RCALL	_CLCD_rd_stat
	TST 	dcnt_CLCD
	BREQ	9f
	SBRC	r24, 7
	RJMP	1b
9:
RETURN

BEGIN	_CLCD_wait_ms	; void wait_ms(BYTE); // REG:r24
	MOV 	dcnt_CLCD, r24
1:
	TST 	dcnt_CLCD
	BRNE	1b
RETURN

#ifdef LCD_IS_MULTI_LINES
#	define FUNCSET_N 0x08
#else
#	define FUNCSET_N 0
#endif

BEGIN	_CLCD_init	; void CLCD_init(BYTE); // REG:r25-22
; r24=0 2x16LCD r24!=0 1x16LCD
#if ( defined(TWIN_LCD) && !defined(I2C_LEDMATRIX))
	LDI 	CLCD_NO, 1
	RCALL	100f
	LDI 	CLCD_NO, 0
100:
#endif /* TWIN_LCD */
	SW_LED_DI
	LCD_E_DI	; E=L
	CBI 	LCD_RS_PT	; RS=L
	CBI 	LCD_RW_PT	; RS=L

	LDI 	r24, 30	; wait 30ms
	RCALL	_CLCD_wait_ms

	IN  	r25, PORTB
	LDI 	r24, 0x03
	RCALL	_CLCD_wr_nibble
	LDI 	r24, 8	; wait 8ms
	RCALL	_CLCD_wait_ms

	LDI 	r24, 0x03
	RCALL	_CLCD_wr_nibble
	LDI 	r24, 2	; wait 2ms
	RCALL	_CLCD_wait_ms

	LDI 	r24, 0x03
	RCALL	_CLCD_wr_nibble
	LDI 	r24, 2	; wait 2ms
	RCALL	_CLCD_wait_ms

	LDI 	r24, 0x02
	RCALL	_CLCD_wr_nibble
	LDI 	r24, 2	; wait 2ms
	RCALL	_CLCD_wait_ms

	OUT 	PORTB, r25

; set function(4bit bus mode)
	LDI 	r24, 0x20|FUNCSET_N
	RCALL	_CLCD_cmd_nowait

; display off CLCD
	LDI 	r24, 0x08
	RCALL	_CLCD_cmd

; clear CLCD
	LDI 	r24, 0x01
	RCALL	_CLCD_cmd

; set entry mode
	LDI 	r24, 0x06
	RCALL	_CLCD_cmd

; display on CLCD
	LDI 	r24, 0x0c
	RCALL	_CLCD_cmd

RETURN


#if 0
;	*****************  CLCD_display sub-routines   *****************

BEGIN _CLCD_POS 	; void CLCD_POS(BYTE); // REG:r25-22
; cursor on if MSB is set, off if MSB is cleared
	MOV 	r25, r24
	RCALL	_CLCD_cmd
	LDI 	r24, 0x0C	; display on/cursor off/blink off
	SBRC	r25, 7
	ORI 	r24, 0x03	; cursor on/blink on
	RJMP	_CLCD_cmd
ENDFN
BEGIN _CLCD_LINE1 	; void CLCD_LINE1(void); // REG:r25-22
	LDI 	r24, 0x80
	RCALL	_CLCD_cmd
RETURN

BEGIN _CLCD_LINE2 	; void CLCD_LINE2(void); // REG:r25-22
	LDI 	r24, 0xC0
	RCALL	_CLCD_cmd
RETURN

BEGIN _CLCD_BYTEOUT ; void CLCD_BYTEOUT(BYTE); // REG:r25-22
	MOV 	r25, r24
	SWAP	r24
	RCALL	_HEX2CHR
	RCALL	_CLCD_dat
	MOV 	r24, r25
	RCALL	_HEX2CHR
	RJMP	_CLCD_dat
ENDFN

BEGIN _CLCD_SPCOUT ; void CLCD_SPCOUT(void); // REG:r25-22
	LDI 	r24, ' '
ENDFN
BEGIN _CLCD_putc ; void CLCD_putc(BYTE); // REG:r25-22
	RJMP	_CLCD_dat
ENDFN
#endif
BEGIN _CLCD_puts ; void CLCD_puts(char *); // REG:r25-21
	MOV 	r21, r24
1:
	RCALL	_GET_const_STR
	TST 	r24
	BREQ	9f
	RCALL	_CLCD_dat
	INC 	r21
	MOV 	r24, r21
	RJMP	1b
9:
RETURN

.end
